function value = TRAP( F , A , B, N )
% returns the N-interval composite trapezoidal rule approximation to
%   int_A^B f(x) dx
% with  f  the function associated with the function handle  F 

H = (B-A)/N; X = H*(1:N-1);
value = H*(F(A)/2 + sum(F(X)) + F(B)/2);
return, end
