%MATLAB version of FORTRAN program for Example 8.5 on page 377 of conte/deboor
SOLN = @(X) exp(X)-1-X;
F = @(x,y) x+y;

disp('Adams-Bashforth Method')
disp('   N    XN              YN              Y(XN)           ERROR')
NSTEPS = 32; H = 1/NSTEPS; YBEGIN = 0; XBEGIN = 0;
f = zeros(1,NSTEPS);

   % compute the first four points using the exact solution

f(1) = F(XBEGIN,YBEGIN);
N = 0; 
fprintf('  %2d   %15.8e %15.8e %15.8e %15.8e\n', ...
            [N,XBEGIN,YBEGIN,SOLN(XBEGIN),0])
for N=1:3
   XN = XBEGIN + N*H; YN = SOLN(XN); f(N+1) = F(XN,YN);
   fprintf('  %2d   %15.8e %15.8e %15.8e %15.8e\n', [N,XN,YN,YN,0])
end
   % begin iteration
for N=4:NSTEPS
   YN = YN +(H/24)*f(N-3:N)*[-9;37;-59;55]; XN = XBEGIN+N*H; f(N+1) = F(XN,YN);
   YOFXN = SOLN(XN); 
   fprintf('  %2d   %15.8e %15.8e %15.8e %15.8e\n', ...
               [N,XN,YN,YOFXN,YOFXN-YN])
end
disp(' ')
disp(' the numerical results are slightly better than shown in the book since')
disp(' the calculations are done in double precision (standard for MATLAB)')
